/*
 * AceptacionesGestion
 * 
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * Gestion de aceptaciones. (Para recepcionamiento de materias primas)
 * Defiere de AceptacionForm en la posibilidad de altas y bajas.
 * 
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;
using System.Data;
using MySql.Data.MySqlClient;
using System.Drawing.Printing;

namespace FormulacionMagistral
{
	/// <summary>
	/// Description of AceptacionesGestion.
	/// </summary>
	public class AceptacionesGestion : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label lblAceptacionID;
		private System.Windows.Forms.Button btnFirst;
		private System.Windows.Forms.TextBox txtPersonalIDCurrent;
		private System.Windows.Forms.Button btnImprimir;
		private System.Windows.Forms.Button btnNuevo;
		private System.Windows.Forms.Label lblFecha;
		private System.Windows.Forms.Label lblPos;
		private System.Windows.Forms.Button btnGuardar;
		private System.Windows.Forms.Label lblPersonalIDCurrent;
		private System.Windows.Forms.TextBox txtPersonalID;
		private System.Windows.Forms.Button btnPrev;
		private System.Windows.Forms.CheckBox chkContenido;
		private System.Windows.Forms.TextBox txtFecha;
		private System.Windows.Forms.Button btnBorrar;
		private System.Windows.Forms.TextBox txtAceptacionID;
		private System.Windows.Forms.Label lblContenido;
		private System.Windows.Forms.Button btnNext;
		private System.Windows.Forms.Button btnLast;
		private System.Windows.Forms.Label lblPersonalID;
		
		
		private MySqlConnection conn;
		private MySqlDataAdapter adap;  
		private System.Data.DataSet ds;
		private MySqlParameter parm;
		
	
		// Algunas variables para emular el CurrencyManager defectuoso de Mono
		private int RecCount;
		private int RecPosition;
				
		// Para cargar preferencias de la BD
		private Formulacion.PreferenciasDB DBPrefs;
		
		// Informacion para conexion BD
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;
		
		
		
		// Nivel de acceso
		private int currentlevel;
		private Alertas AlertaLocal; // Alertas

		
		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="level">Nivel de acceso</param>
		/// <param name="personalid">ID del usuario actual</param>
		public AceptacionesGestion(int level, int personalid)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			this.currentlevel = level;
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			this.RecPosition = -1;
			this.txtPersonalIDCurrent.Text = personalid.ToString();
			AlertaLocal = new Alertas();
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.lblPersonalID = new System.Windows.Forms.Label();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.lblContenido = new System.Windows.Forms.Label();
			this.txtAceptacionID = new System.Windows.Forms.TextBox();
			this.btnBorrar = new System.Windows.Forms.Button();
			this.txtFecha = new System.Windows.Forms.TextBox();
			this.chkContenido = new System.Windows.Forms.CheckBox();
			this.btnPrev = new System.Windows.Forms.Button();
			this.txtPersonalID = new System.Windows.Forms.TextBox();
			this.lblPersonalIDCurrent = new System.Windows.Forms.Label();
			this.btnGuardar = new System.Windows.Forms.Button();
			this.lblPos = new System.Windows.Forms.Label();
			this.lblFecha = new System.Windows.Forms.Label();
			this.btnNuevo = new System.Windows.Forms.Button();
			this.btnImprimir = new System.Windows.Forms.Button();
			this.txtPersonalIDCurrent = new System.Windows.Forms.TextBox();
			this.btnFirst = new System.Windows.Forms.Button();
			this.lblAceptacionID = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// lblPersonalID
			// 
			this.lblPersonalID.Location = new System.Drawing.Point(16, 80);
			this.lblPersonalID.Name = "lblPersonalID";
			this.lblPersonalID.Size = new System.Drawing.Size(128, 16);
			this.lblPersonalID.TabIndex = 27;
			this.lblPersonalID.Text = "Personal ID";
			// 
			// btnLast
			// 
			this.btnLast.Location = new System.Drawing.Point(528, 176);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 24);
			this.btnLast.TabIndex = 26;
			this.btnLast.Text = "->|";
			this.btnLast.Click += new System.EventHandler(this.BtnLastClick);
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(496, 176);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 24);
			this.btnNext.TabIndex = 25;
			this.btnNext.Text = "->";
			this.btnNext.Click += new System.EventHandler(this.BtnNextClick);
			// 
			// lblContenido
			// 
			this.lblContenido.Location = new System.Drawing.Point(16, 176);
			this.lblContenido.Name = "lblContenido";
			this.lblContenido.Size = new System.Drawing.Size(88, 16);
			this.lblContenido.TabIndex = 15;
			this.lblContenido.Text = "Contenido";
			// 
			// txtAceptacionID
			// 
			this.txtAceptacionID.Location = new System.Drawing.Point(152, 144);
			this.txtAceptacionID.Name = "txtAceptacionID";
			this.txtAceptacionID.Size = new System.Drawing.Size(240, 20);
			this.txtAceptacionID.TabIndex = 11;
			this.txtAceptacionID.Text = "";
			// 
			// btnBorrar
			// 
			this.btnBorrar.Location = new System.Drawing.Point(432, 88);
			this.btnBorrar.Name = "btnBorrar";
			this.btnBorrar.Size = new System.Drawing.Size(120, 24);
			this.btnBorrar.TabIndex = 29;
			this.btnBorrar.Text = "Borrar";
			this.btnBorrar.Click += new System.EventHandler(this.BtnBorrarClick);
			// 
			// txtFecha
			// 
			this.txtFecha.Location = new System.Drawing.Point(152, 112);
			this.txtFecha.Name = "txtFecha";
			this.txtFecha.Size = new System.Drawing.Size(240, 20);
			this.txtFecha.TabIndex = 17;
			this.txtFecha.Text = "";
			// 
			// chkContenido
			// 
			this.chkContenido.Location = new System.Drawing.Point(152, 176);
			this.chkContenido.Name = "chkContenido";
			this.chkContenido.Size = new System.Drawing.Size(168, 16);
			this.chkContenido.TabIndex = 18;
			this.chkContenido.Text = "Aprobado";
			// 
			// btnPrev
			// 
			this.btnPrev.Location = new System.Drawing.Point(368, 176);
			this.btnPrev.Name = "btnPrev";
			this.btnPrev.Size = new System.Drawing.Size(32, 24);
			this.btnPrev.TabIndex = 24;
			this.btnPrev.Text = "<-";
			this.btnPrev.Click += new System.EventHandler(this.BtnPrevClick);
			// 
			// txtPersonalID
			// 
			this.txtPersonalID.Location = new System.Drawing.Point(152, 80);
			this.txtPersonalID.Name = "txtPersonalID";
			this.txtPersonalID.Size = new System.Drawing.Size(240, 20);
			this.txtPersonalID.TabIndex = 28;
			this.txtPersonalID.Text = "";
			// 
			// lblPersonalIDCurrent
			// 
			this.lblPersonalIDCurrent.Location = new System.Drawing.Point(16, 16);
			this.lblPersonalIDCurrent.Name = "lblPersonalIDCurrent";
			this.lblPersonalIDCurrent.Size = new System.Drawing.Size(144, 16);
			this.lblPersonalIDCurrent.TabIndex = 13;
			this.lblPersonalIDCurrent.Text = "Personal ID Actual";
			// 
			// btnGuardar
			// 
			this.btnGuardar.Location = new System.Drawing.Point(432, 24);
			this.btnGuardar.Name = "btnGuardar";
			this.btnGuardar.Size = new System.Drawing.Size(120, 24);
			this.btnGuardar.TabIndex = 21;
			this.btnGuardar.Text = "Guardar";
			this.btnGuardar.Click += new System.EventHandler(this.BtnGuardarClick);
			// 
			// lblPos
			// 
			this.lblPos.Location = new System.Drawing.Point(400, 176);
			this.lblPos.Name = "lblPos";
			this.lblPos.Size = new System.Drawing.Size(96, 16);
			this.lblPos.TabIndex = 20;
			this.lblPos.Text = "0 de 0";
			this.lblPos.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblFecha
			// 
			this.lblFecha.Location = new System.Drawing.Point(16, 112);
			this.lblFecha.Name = "lblFecha";
			this.lblFecha.Size = new System.Drawing.Size(88, 16);
			this.lblFecha.TabIndex = 14;
			this.lblFecha.Text = "Fecha";
			// 
			// btnNuevo
			// 
			this.btnNuevo.Location = new System.Drawing.Point(432, 56);
			this.btnNuevo.Name = "btnNuevo";
			this.btnNuevo.Size = new System.Drawing.Size(120, 24);
			this.btnNuevo.TabIndex = 22;
			this.btnNuevo.Text = "Nueva";
			this.btnNuevo.Click += new System.EventHandler(this.BtnNuevoClick);
			// 
			// btnImprimir
			// 
			this.btnImprimir.Location = new System.Drawing.Point(432, 120);
			this.btnImprimir.Name = "btnImprimir";
			this.btnImprimir.Size = new System.Drawing.Size(120, 24);
			this.btnImprimir.TabIndex = 30;
			this.btnImprimir.Text = "Imprimir";
			this.btnImprimir.Click += new System.EventHandler(this.BtnImprimirClick);
			// 
			// txtPersonalIDCurrent
			// 
			this.txtPersonalIDCurrent.Enabled = false;
			this.txtPersonalIDCurrent.Location = new System.Drawing.Point(152, 16);
			this.txtPersonalIDCurrent.Name = "txtPersonalIDCurrent";
			this.txtPersonalIDCurrent.Size = new System.Drawing.Size(240, 20);
			this.txtPersonalIDCurrent.TabIndex = 16;
			this.txtPersonalIDCurrent.Text = "";
			// 
			// btnFirst
			// 
			this.btnFirst.Location = new System.Drawing.Point(336, 176);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 24);
			this.btnFirst.TabIndex = 23;
			this.btnFirst.Text = "|<-";
			this.btnFirst.Click += new System.EventHandler(this.BtnFirstClick);
			// 
			// lblAceptacionID
			// 
			this.lblAceptacionID.Location = new System.Drawing.Point(16, 144);
			this.lblAceptacionID.Name = "lblAceptacionID";
			this.lblAceptacionID.Size = new System.Drawing.Size(88, 16);
			this.lblAceptacionID.TabIndex = 12;
			this.lblAceptacionID.Text = "Aceptacion ID";
			// 
			// AceptacionesGestion
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(578, 223);
			this.Controls.Add(this.btnImprimir);
			this.Controls.Add(this.btnBorrar);
			this.Controls.Add(this.txtPersonalID);
			this.Controls.Add(this.lblPersonalID);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnPrev);
			this.Controls.Add(this.btnFirst);
			this.Controls.Add(this.btnNuevo);
			this.Controls.Add(this.btnGuardar);
			this.Controls.Add(this.lblPos);
			this.Controls.Add(this.chkContenido);
			this.Controls.Add(this.txtFecha);
			this.Controls.Add(this.txtPersonalIDCurrent);
			this.Controls.Add(this.lblContenido);
			this.Controls.Add(this.lblFecha);
			this.Controls.Add(this.lblPersonalIDCurrent);
			this.Controls.Add(this.lblAceptacionID);
			this.Controls.Add(this.txtAceptacionID);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "AceptacionesGestion";
			this.Text = "Gestion de aceptaciones";
			this.Load += new System.EventHandler(this.AceptacionesGestionLoad);
			this.ResumeLayout(false);
		}
		#endregion
		
		
				/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}
		
		/// <summary>
		/// Obtiene el id del registro actual
		/// </summary>
		/// <returns>Devuelve un entero del ID del registro</returns>
		public int getcurrentid(){
			int n;
			try{
				n = Convert.ToInt32( this.txtAceptacionID.Text);
				return n;
			}catch(Exception ex){
				FM_Errores.MostrarError("GetCurrentID","No se puede obtener el ID actual",ex);
				return -1;
			}
		}
		
		
		private bool Conectar(int registro){
			try{
		 	conn = new MySqlConnection("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");

		 	adap = new MySqlDataAdapter();
			ds = new System.Data.DataSet();
			
			if( registro >= 0){
		 		adap.SelectCommand = new MySqlCommand("SELECT * FROM aceptaciones WHERE AceptacionID="+ registro.ToString() + ";",conn);
		 		
			}
		 	else{
			 	adap.SelectCommand = new MySqlCommand("SELECT * FROM aceptaciones;",conn);
				}
			adap.Fill(ds,"Aceptaciones");
		 	
		 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("AceptacionesForm","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("AceptacionesForm","Error general. No se puede cargar la informacin",e);
				return false;
			}
		 	
		}

		private void CargarComandoUpdate(){
			adap.UpdateCommand = new MySqlCommand("Update aceptaciones Set PersonalID = ?PersonalID, Fecha = ?Fecha, Contenido=?Contenido WHERE AceptacionID = ?AceptacionID",conn);
			
			parm = adap.UpdateCommand.Parameters.Add("?AceptacionID", MySqlDbType.Int32);
			parm.SourceColumn = "AceptacionID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.UpdateCommand.Parameters.Add("?PersonalID", MySqlDbType.Int32);
			parm.SourceColumn = "PersonalID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.UpdateCommand.Parameters.Add("?Fecha", MySqlDbType.VarChar, 45 );
			parm.SourceColumn = "Fecha";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.UpdateCommand.Parameters.Add("?Contenido", MySqlDbType.Int32);
			parm.SourceColumn = "Contenido";
			parm.SourceVersion = DataRowVersion.Current;
			
		}
		
		private void CargarComandoDelete(){
			adap.DeleteCommand = new MySqlCommand("DELETE FROM aceptaciones WHERE AceptacionID = ?AceptacionID",conn);
			
			parm = adap.DeleteCommand.Parameters.Add("?AceptacionID", MySqlDbType.Int32);
			parm.SourceColumn = "AceptacionID";
			parm.SourceVersion = DataRowVersion.Original;
			
		}
		
		private void CargarComandoInsert(){
			adap.InsertCommand = new MySqlCommand("Insert into aceptaciones(AceptacionID, PersonalID, Fecha, Contenido) VALUES (?AceptacionID, ?PersonalID, ?Fecha, ?Contenido)",conn);
			
			parm = adap.InsertCommand.Parameters.Add("?AceptacionID", MySqlDbType.Int32);
			parm.SourceColumn = "AceptacionID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.InsertCommand.Parameters.Add("?PersonalID", MySqlDbType.Int32);
			parm.SourceColumn = "PersonalID";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.InsertCommand.Parameters.Add("?Fecha", MySqlDbType.VarChar, 45 );
			parm.SourceColumn = "Fecha";
			parm.SourceVersion = DataRowVersion.Current;
			
			parm = adap.InsertCommand.Parameters.Add("?Contenido", MySqlDbType.Int32);
			parm.SourceColumn = "Contenido";
			parm.SourceVersion = DataRowVersion.Current;

		}

		
		void AceptacionesGestionLoad(object sender, System.EventArgs e)
		{
			this.CargarConfiguracionDatabase();
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			if ( this.Conectar(this.RecPosition) )
			{
				this.RecPosition = 0;
				this.CargarComandoUpdate();
				this.CargarComandoInsert();
				this.CargarComandoDelete();
				this.RecCount = ds.Tables[0].Rows.Count;
				
			    MostrarPosicion();
			    this.CargarRegistro(this.RecPosition);
			}

		}
		
		void MostrarPosicion(){
			this.lblPos.Text = (this.RecPosition+1).ToString() + " de " + this.RecCount.ToString();
		}

		void CargarRegistro( int numero){
			if( numero >=0 && numero < ds.Tables[0].Rows.Count)
			{
				
				this.txtAceptacionID.Text = ds.Tables[0].Rows[numero]["AceptacionID"].ToString();
				this.txtPersonalID.Text = ds.Tables[0].Rows[numero]["PersonalID"].ToString();
				this.txtFecha.Text = ds.Tables[0].Rows[numero]["Fecha"].ToString();
				
				if( Convert.ToInt32 (ds.Tables[0].Rows[numero]["Contenido"]) != 0)
					this.chkContenido.Checked = true;
				else
					this.chkContenido.Checked = false;
			}
		}

		void GuardarRegistro(int numero){
			try{
			ds.Tables[0].Rows[numero].BeginEdit();
			ds.Tables[0].Rows[numero]["AceptacionID"] = this.txtAceptacionID.Text;
			ds.Tables[0].Rows[numero]["PersonalID"] = this.txtPersonalID.Text;
			ds.Tables[0].Rows[numero]["Fecha"] = this.txtFecha.Text;
			
			if( this.chkContenido.Checked)
				ds.Tables[0].Rows[numero]["Contenido"] = 1;
			else
				ds.Tables[0].Rows[numero]["Contenido"] = 0;
			
			ds.Tables[0].Rows[numero].EndEdit();
			}catch(Exception ex){
				FM_Errores.MostrarError("AceptacionesForm","No se puede modificar el registro",ex);
			}
			
		}

		
		void BtnGuardarClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para guardar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(83); // Modulo 8: Aceptaciones, accion 3: Modificar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar modificar los datos de aceptaciones con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite modificar los datos");
				return;
			}
			
			GuardarRegistro(this.RecPosition);
			GuardarModificaciones();

		}
	
		void GuardarModificaciones()
		{
			try
    			{
        		int Modificaciones= 0; 
        			Modificaciones += adap.Update(ds,"Aceptaciones");
        			ds.Clear();
        			adap.Fill(ds,"Aceptaciones");
        			this.RecPosition=0;
        			this.RecCount = ds.Tables[0].Rows.Count;
        			this.CargarRegistro (this.RecPosition );
        			this.MostrarPosicion();
        			FM_Errores.MostrarAviso("Actualizacion correcta","Actualizados "+Modificaciones+" registros");
        			
				}catch (Exception ex){
					FM_Errores.MostrarError("Actualizacion","Error actualizando datos",ex);
        	    }
			
		}

		void BtnNuevoClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para nuevo
			try{
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(82); // Modulo 8: Aceptaciones, accion 2:Nuevo
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar aadir una aceptacion con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite aadir datos");
				return;
			}
			
			object[] ro1 = new Object[ds.Tables[0].Columns.Count];
			ro1[1] = (int) Convert.ToInt32 ( this.txtPersonalIDCurrent.Text);
			ro1[2] = (string) DateTime.Now.ToString();
			ro1[3] = (int) 1;
			ds.Tables[0].Rows.Add(ro1);
			this.RecCount = ds.Tables[0].Rows.Count;
			this.RecPosition = this.RecCount-1;
			
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
			}catch(Exception ex){
				FM_Errores.MostrarError("Nueva aceptacion","No se puede introducir una nueva aceptacion",ex);
			}
		}

		void Borrado(object sender, System.Data.DataRowChangeEventArgs e)
		{
			DataRow[] pendientes;
			try{
			pendientes = ds.Tables[0].Select("", "", DataViewRowState.Deleted);
			FM_Errores.MostrarAviso("Borrado","Se han borrado " + adap.Update(pendientes).ToString() + " registros");
					ds.Clear();
        			adap.Fill(ds,"Aceptaciones");
        			this.RecPosition=0;
        			this.RecCount = ds.Tables[0].Rows.Count;
        			this.CargarRegistro (this.RecPosition );
        			this.MostrarPosicion();

			}catch(Exception ex){
				FM_Errores.MostrarError("AceptacionesGestion","No se puede borrar",ex);
			}
		}
		
		
		void BtnBorrarClick(object sender, System.EventArgs e)
		{
			int l; // Nivel para borrar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(81); // Modulo 8: Aceptaciones, accion 3: Borrar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar borrar aceptaciones con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite borrar datos");
				return;
			}

			if (MessageBox.Show("Esta seguro (esta accion puede desestabilizar varios registro de la aplicacion)?", "Confirmacin", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
				return;
			
			try{
			ds.Tables[0].RowDeleted += new System.Data.DataRowChangeEventHandler(Borrado);
			ds.Tables["Aceptaciones"].Rows.RemoveAt( this.RecPosition);
			}catch(Exception ex){
				FM_Errores.MostrarError("AceptacionesGestion","No se puede borrar",ex);
			}

		}
		
		void BtnImprimirClick(object sender, System.EventArgs e)
		{
			try{
			Formulacion.Impresiones docMaterial = new Formulacion.Impresiones();
			PrintPreviewDialog prevDialog = new PrintPreviewDialog();
			PrintDialog prdialog = new PrintDialog();
			
			docMaterial.ImprimirCabezera();
			docMaterial.NuevoTexto("Informe de aceptacion.");
			
			
			
			docMaterial.NuevaLinea();
			docMaterial.NuevoTexto("ID de aceptacion: " + ds.Tables[0].Rows[this.RecPosition]["AceptacionID"].ToString());
			docMaterial.NuevoTexto("ID de personal autorizador: " + ds.Tables[0].Rows[this.RecPosition]["PersonalID"].ToString());
			docMaterial.NuevoTexto("Fecha: " + ds.Tables[0].Rows[this.RecPosition]["Fecha"].ToString());
			
			if ( Convert.ToInt32 (ds.Tables[0].Rows[this.RecPosition]["Contenido"].ToString()) != 0 )
				docMaterial.NuevoTexto("Estado: Aceptado");
			else
				docMaterial.NuevoTexto("Estado: No aceptado");
				        
			docMaterial.NuevoTexto("");
			
			
			prevDialog.Document = docMaterial;
			prdialog.Document = docMaterial;
			
			docMaterial.PrintPage += new PrintPageEventHandler(docMaterial.ImprimirElementos);
			docMaterial.BeginPrint += new PrintEventHandler (docMaterial.Reajustar);
			
			// Esto esta por ser configurable en fichero XML o DB
			// docMaterial.MuestraPrefsPagina();
			
			
			// Esto tambien deberia ser configurable
			prevDialog.Text = "Previsualizacion del informe de aceptacion";
			prevDialog.ShowDialog();
			
			if (prdialog.ShowDialog()== DialogResult.OK)
			{
				docMaterial.Print();
			}

			
			}catch(Exception ex){
				FM_Errores.MostrarError("Impresion","No se puede imprimir",ex);
			}
			
		}
		
		
		void BtnFirstClick(object sender, System.EventArgs e)
		{
			this.RecPosition = 0;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnPrevClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition > 0)
			this.RecPosition--;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
			
		}
		
		void BtnNextClick(object sender, System.EventArgs e)
		{
			if( this.RecPosition < this.RecCount-1)
			this.RecPosition++;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		void BtnLastClick(object sender, System.EventArgs e)
		{
			this.RecPosition = this.RecCount-1;
			this.MostrarPosicion();
			this.CargarRegistro(this.RecPosition);
		}
		
		
	}
}
