/*
 * 
 * HelpDetail.cs
 * 
 * (C) Alvaro Cortes. 2007. alvarocortesc@gmail.com
 * 
 * 
 * Muestra los detalles de ayuda de un tema determinado.
 * 
 */

using System;
using System.Drawing;
using System.Windows.Forms;

namespace FormulacionMagistral
{
	/// <summary>
	/// Description of HelpDetail.
	/// </summary>
	public class HelpDetail : System.Windows.Forms.Form
	{
		private System.Windows.Forms.RichTextBox richAyuda;
		private System.Windows.Forms.Button btnCerrar;
		
		private string tema; // ID del tema
		
		private Farmakito.DataFarmakito DFark;
		private Formulacion.PreferenciasDB DBPrefs;
		
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;

		
		/// <summary>
		/// Saca un formulario con el tema de ayuda en cuestion
		/// </summary>
		/// <param name="temaid">Nombre del tema en cuestion</param>
		public HelpDetail(string temaid)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			InitializeComponent();
			tema = temaid;
						
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnCerrar = new System.Windows.Forms.Button();
			this.richAyuda = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// btnCerrar
			// 
			this.btnCerrar.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.btnCerrar.Location = new System.Drawing.Point(0, 341);
			this.btnCerrar.Name = "btnCerrar";
			this.btnCerrar.Size = new System.Drawing.Size(552, 24);
			this.btnCerrar.TabIndex = 2;
			this.btnCerrar.Text = "Cerrar";
			this.btnCerrar.Click += new System.EventHandler(this.BtnCerrarClick);
			// 
			// richAyuda
			// 
			this.richAyuda.AutoSize = true;
			this.richAyuda.Dock = System.Windows.Forms.DockStyle.Fill;
			this.richAyuda.Location = new System.Drawing.Point(0, 0);
			this.richAyuda.Name = "richAyuda";
			this.richAyuda.ReadOnly = true;
			this.richAyuda.Size = new System.Drawing.Size(552, 341);
			this.richAyuda.TabIndex = 3;
			this.richAyuda.Text = "";
			// 
			// HelpDetail
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 365);
			this.Controls.Add(this.richAyuda);
			this.Controls.Add(this.btnCerrar);
			this.Name = "HelpDetail";
			this.Text = "Detalles Ayuda";
			this.Load += new System.EventHandler(this.HelpDetailLoad);
			this.ResumeLayout(false);
		}
		#endregion
		
		
		
		void HelpDetailLoad(object sender, System.EventArgs e)
		{
			string rtffichero;
			this.CargarConfiguracionDatabase();
			DFark = new Farmakito.DataFarmakito();
			DFark.AsignaParametrosConexion(this.dbhost,this.dbport,this.dbuser, this.dbpasoteword,"formulacion");
			try{
			if ( DFark.Conectar() )
			{
				
				rtffichero = (string) DFark.GetText(tema);
				DFark.Desconectar();
			
			richAyuda.LoadFile(rtffichero);
			}
			}catch(Exception ex){
				FM_Errores.MostrarError("Ayuda","No se puede mostrar la ayuda",ex);
			}
			
		}
		
		
		/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}

		
		void BtnCerrarClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
	}
}
