/*
 * 
 * (C) Alvaro Corts. 2007. accsc@arbornet.org
 * 
 *  Visor de alertas de la aplicacion formulacion magistral
 */

using System;
using System.Drawing;
using System.Windows.Forms;

using System.Drawing.Printing;
using MySql.Data.MySqlClient;
using System.Data;


namespace FormulacionMagistral
{
	/// <summary>
	/// Description of VisorAlertas.
	/// </summary>
	public class VisorAlertas : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnImprimir;
		private System.Windows.Forms.Button btnBorrar;
		private System.Windows.Forms.Button btnCerrar;
		private System.Windows.Forms.ListBox lstAlertas;
		private System.Windows.Forms.Button btnActualizar;

		private Alertas AlertaLocal; // Alertas
		private int currentlevel;   // Nivel de autorizacion del usuario actual
		
		#region Objetos de la base de datos (Adapters, Connection, DataSets)
		
		private MySqlDataAdapter adap;  // adapter general
		private DataSet ds;               // ds general
		private MySqlConnection conn;      // conexion 

		#endregion
		
		// Para cargar preferencias de la BD
		private Formulacion.PreferenciasDB DBPrefs;
		
		// Informacion para conexion BD
		private string dbhost;
		private string dbport;
		private string dbuser;
		private string dbpasoteword;

		
		/// <summary>
		/// Contructor de la clase
		/// </summary>
		/// <param name="nivel">Nivel de acceso</param>
		public VisorAlertas(int nivel)
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			this.currentlevel = nivel;
			
			DBPrefs = new Formulacion.PreferenciasDB();
			DBPrefs.AsignarNmbFichero("PrefDataBase.xml");
			
			AlertaLocal = new Alertas();

		}
		/// <summary>
		/// Carga la configuracin de la base de datos en la vars
		/// de la clase
		/// </summary>
		void CargarConfiguracionDatabase(){
			string[] prf;
			if ( this.DBPrefs.LeerFichero() )
			{
				prf = this.DBPrefs.CargarPreferenciasDB();
				
				for( int i = 0; i < prf.Length; ++i)
				{
					switch(i){
						case 0: this.dbhost = prf[0]; break;
						case 1: this.dbport = prf[1]; break;
						case 3: this.dbuser = prf[2]; break;
						case 4: this.dbpasoteword = prf[3]; break;
					
					}
				}
				this.DBPrefs.CerrarEntrada();
			}
		}

		private bool Conectar(){
			try{
		 	conn = new MySqlConnection("host="+this.dbhost+";port=" + this.dbport + ";user id="+this.dbuser+";password="+this.dbpasoteword+ ";database=formulacion");

		 	adap = new MySqlDataAdapter();
			ds = new System.Data.DataSet();
			
			 	adap.SelectCommand = new MySqlCommand("SELECT * FROM alertas;",conn);
			 	adap.DeleteCommand = new MySqlCommand("DELETE FROM alertas;",conn);
			

				adap.Fill(ds,"Alertas");
		 	return true;
			}catch(MySqlException ex){
				FM_Errores.MostrarError("VisorAlertas","Error relacionado con base de datos",ex);
				return false;
			}catch(Exception e){
				FM_Errores.MostrarError("VisorAlertas","Error general. No se pueden cargar las alertas",e);
				return false;
			}
		 	
		}

		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.btnActualizar = new System.Windows.Forms.Button();
			this.lstAlertas = new System.Windows.Forms.ListBox();
			this.btnCerrar = new System.Windows.Forms.Button();
			this.btnBorrar = new System.Windows.Forms.Button();
			this.btnImprimir = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnActualizar
			// 
			this.btnActualizar.Location = new System.Drawing.Point(8, 8);
			this.btnActualizar.Name = "btnActualizar";
			this.btnActualizar.Size = new System.Drawing.Size(72, 16);
			this.btnActualizar.TabIndex = 5;
			this.btnActualizar.Text = "Actualizar";
			this.btnActualizar.Click += new System.EventHandler(this.BtnActualizarClick);
			// 
			// lstAlertas
			// 
			this.lstAlertas.HorizontalScrollbar = true;
			this.lstAlertas.Location = new System.Drawing.Point(8, 24);
			this.lstAlertas.Name = "lstAlertas";
			this.lstAlertas.Size = new System.Drawing.Size(584, 277);
			this.lstAlertas.TabIndex = 2;
			// 
			// btnCerrar
			// 
			this.btnCerrar.Location = new System.Drawing.Point(144, 320);
			this.btnCerrar.Name = "btnCerrar";
			this.btnCerrar.Size = new System.Drawing.Size(96, 32);
			this.btnCerrar.TabIndex = 1;
			this.btnCerrar.Text = "Cerrar";
			this.btnCerrar.Click += new System.EventHandler(this.BtnCerrarClick);
			// 
			// btnBorrar
			// 
			this.btnBorrar.Location = new System.Drawing.Point(256, 320);
			this.btnBorrar.Name = "btnBorrar";
			this.btnBorrar.Size = new System.Drawing.Size(96, 32);
			this.btnBorrar.TabIndex = 3;
			this.btnBorrar.Text = "Borrar registro";
			this.btnBorrar.Click += new System.EventHandler(this.BtnBorrarClick);
			// 
			// btnImprimir
			// 
			this.btnImprimir.Location = new System.Drawing.Point(368, 320);
			this.btnImprimir.Name = "btnImprimir";
			this.btnImprimir.Size = new System.Drawing.Size(104, 32);
			this.btnImprimir.TabIndex = 4;
			this.btnImprimir.Text = "Imprimir";
			this.btnImprimir.Click += new System.EventHandler(this.BtnImprimirClick);
			// 
			// VisorAlertas
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 357);
			this.Controls.Add(this.btnActualizar);
			this.Controls.Add(this.btnImprimir);
			this.Controls.Add(this.btnBorrar);
			this.Controls.Add(this.lstAlertas);
			this.Controls.Add(this.btnCerrar);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "VisorAlertas";
			this.Text = "VisorAlertas";
			this.Load += new System.EventHandler(this.VisorAlertasLoad);
			this.ResumeLayout(false);
		}
		#endregion
		void VisorAlertasLoad(object sender, System.EventArgs e)
		{
			this.CargarConfiguracionDatabase();
			AlertaLocal.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");
			if ( this.Conectar() )
			{
				for(int i=0; i< ds.Tables[0].Rows.Count; ++i)
					this.lstAlertas.Items.Add(ds.Tables[0].Rows[i]["Fecha"].ToString() + " - " + ds.Tables[0].Rows[i]["Contenido"].ToString());
			}

		}
		
		void BtnBorrarClick(object sender, System.EventArgs e)
		{
			
			int l; // Nivel para borrar
			AuthLevel al = new AuthLevel();
			al.setConnectionParameters(this.dbhost ,this.dbport ,this.dbuser ,this.dbpasoteword ,"formulacion");

			l = al.get_level(93); // Modulo 9: Alertas, accion 3: Borrar
			
			if(	this.currentlevel < l ){
				if( !AlertaLocal.registra_alerta("Error de seguridad al intentar borrar los datos de alertas de seguridad con el nivel de autorizacion " + this.currentlevel.ToString()))
				{
					FM_Errores.MostrarError("Error al registrar alerta de seguridad");
				}

				FM_Errores.MostrarError("Seguridad","Su nivel de autorizacin no le permite borrar datos");
				return;
			}
			
			if (MessageBox.Show("Esta seguro?", "Confirmacin", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
				return;

			
			try{
			this.lstAlertas.Items.Clear();
			for(int i=0; i< ds.Tables[0].Rows.Count; ++i)
				ds.Tables[0].Rows[i].Delete();
			adap.Update(ds,"Alertas");
			
			this.AlertaLocal.registra_alerta("Se ha procedido a borrar el registro de alertas con el nivel de autorizacion " + this.currentlevel.ToString());

			ds.Clear();
			adap.Fill(ds,"Alertas");

			
			for(int i=0; i< ds.Tables[0].Rows.Count; ++i)
				this.lstAlertas.Items.Add(ds.Tables[0].Rows[i]["Fecha"].ToString() + " - " + ds.Tables[0].Rows[i]["Contenido"].ToString());
			FM_Errores.MostrarAviso("Las alertas han sido borradas");
			
			}catch(Exception ex){
				FM_Errores.MostrarError("VisorAlertas","No se pueden borrar las alertas",ex);
			}
		}
		
		void BtnCerrarClick(object sender, System.EventArgs e)
		{
			this.Close();
		}
		
		void BtnActualizarClick(object sender, System.EventArgs e)
		{
			this.lstAlertas.Items.Clear();
			ds.Clear();
			adap.Fill(ds,"Alertas");

			
			for(int i=0; i< ds.Tables[0].Rows.Count; ++i)
				this.lstAlertas.Items.Add(ds.Tables[0].Rows[i]["Fecha"].ToString() + " - " + ds.Tables[0].Rows[i]["Contenido"].ToString());
		}
		
		void BtnImprimirClick(object sender, System.EventArgs e)
		{
			
			try{
			Formulacion.Impresiones docMaterial = new Formulacion.Impresiones();
			PrintPreviewDialog prevDialog = new PrintPreviewDialog();
			PrintDialog prdialog = new PrintDialog();
			
			docMaterial.ImprimirCabezera();
			docMaterial.NuevoTexto("Listado de alertas.");
			
			
			for(int i=0 ; i<ds.Tables[0].Rows.Count; ++i)
			{
			docMaterial.NuevaLinea();
			docMaterial.NuevoTexto("ID: " + ds.Tables[0].Rows[i]["AlertaID"].ToString());
			docMaterial.NuevoTexto("Fecha: " + ds.Tables[0].Rows[i]["Fecha"].ToString());
			docMaterial.NuevoTexto("Contenido: " + ds.Tables[0].Rows[i]["Contenido"].ToString());
			docMaterial.NuevoTexto("");
			}
			
			prevDialog.Document = docMaterial;
			prdialog.Document = docMaterial;
			
			docMaterial.PrintPage += new PrintPageEventHandler(docMaterial.ImprimirElementos);
			docMaterial.BeginPrint += new PrintEventHandler (docMaterial.Reajustar);
			
			// TODO. Esto esta por ser configurable en fichero XML o DB
			// docMaterial.MuestraPrefsPagina();
			
			
			// TODO. Esto tambien deberia ser configurable
			prevDialog.Text = "Previsualizacion del listado de facultativos seleccionados";
			prevDialog.ShowDialog();

			if (prdialog.ShowDialog()== DialogResult.OK)
			{
				docMaterial.Print();
			}

			
			}catch(Exception ex){
				FM_Errores.MostrarError("Impresion","No se puede imprimir el listado de facultativos",ex);
			}

			
			
		}
		
	}
}
